commit 6dd74062d215682e1f9b3ca618a9d38585dd4831
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Jul 10 21:00:13 2020 +0200

    PR fortran/96086 - ICE in gfc_match_select_rank, at fortran/match.c:6645
    
    Handle NULL pointer dereference on SELECT RANK with an invalid
    assumed-rank array declaration.
    
    gcc/fortran/
            PR fortran/96086
            * match.c (gfc_match_select_rank): Catch NULL pointer
            dereference.
            * resolve.c (resolve_assoc_var): Catch NULL pointer dereference
            that may occur after an illegal declaration.
    
    (cherry picked from commit 8a0b69f0b089c05d233b8e1a941825b1ceac93bd)

diff --git a/gcc/fortran/match.c b/gcc/fortran/match.c
index db5174f3f21..31e302b6b8a 100644
--- a/gcc/fortran/match.c
+++ b/gcc/fortran/match.c
@@ -6642,7 +6642,8 @@ gfc_match_select_rank (void)
       if (expr2->symtree)
 	{
 	  sym2 = expr2->symtree->n.sym;
-	  as = sym2->ts.type == BT_CLASS ? CLASS_DATA (sym2)->as : sym2->as;
+	  as = (sym2->ts.type == BT_CLASS
+		&& CLASS_DATA (sym2)) ? CLASS_DATA (sym2)->as : sym2->as;
 	}
 
       if (expr2->expr_type != EXPR_VARIABLE
@@ -6654,7 +6655,7 @@ gfc_match_select_rank (void)
 	  goto cleanup;
 	}
 
-      if (expr2->ts.type == BT_CLASS)
+      if (expr2->ts.type == BT_CLASS && CLASS_DATA (sym2))
 	{
 	  copy_ts_from_selector_to_associate (expr1, expr2);
 
diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index 354702bda0b..8f7477b6a49 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -8998,7 +8998,9 @@ resolve_assoc_var (gfc_symbol* sym, bool resolve_target)
 	  if (as->corank != 0)
 	    sym->attr.codimension = 1;
 	}
-      else if (sym->ts.type == BT_CLASS && (!CLASS_DATA (sym)->as || sym->assoc->rankguessed))
+      else if (sym->ts.type == BT_CLASS
+	       && CLASS_DATA (sym)
+	       && (!CLASS_DATA (sym)->as || sym->assoc->rankguessed))
 	{
 	  if (!CLASS_DATA (sym)->as)
 	    CLASS_DATA (sym)->as = gfc_get_array_spec ();
diff --git a/gcc/testsuite/gfortran.dg/pr96086.f90 b/gcc/testsuite/gfortran.dg/pr96086.f90
new file mode 100644
index 00000000000..b80967a7a07
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr96086.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/96086 - ICE in gfc_match_select_rank, at fortran/match.c:6645
+
+subroutine s
+  class(*) :: x(..)     ! { dg-error "Assumed-rank array" }
+  select rank (y => x)  ! { dg-error "CLASS variable" }
+  end select
+end

